VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "DBTest"
   ClientHeight    =   5040
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5745
   LinkTopic       =   "Form1"
   ScaleHeight     =   5040
   ScaleWidth      =   5745
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.TreeView trvDatabase 
      Height          =   3975
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   5535
      _ExtentX        =   9763
      _ExtentY        =   7011
      _Version        =   393217
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
   Begin VB.TextBox txtDatabaseName 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   4575
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open"
      Height          =   375
      Left            =   4800
      TabIndex        =   0
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Function DbTypeName(ByVal type_value As Integer) As String
    Select Case type_value
        Case 16
            DbTypeName = "BigInt"
        Case 9
            DbTypeName = "Binary"
        Case 1
            DbTypeName = "Boolean"
        Case 2
            DbTypeName = "Byte"
        Case 18
            DbTypeName = "Char"
        Case 5
            DbTypeName = "Currency"
        Case 8
            DbTypeName = "Date"
        Case 20
            DbTypeName = "Decimal"
        Case 7
            DbTypeName = "Double"
        Case 15
            DbTypeName = "GUID"
        Case 3
            DbTypeName = "Integer"
        Case 4
            DbTypeName = "Long"
        Case 11
            DbTypeName = "LongBinary"
        Case 12
            DbTypeName = "Memo"
        Case 19
            DbTypeName = "Numeric"
        Case 6
            DbTypeName = "Single"
        Case 10
            DbTypeName = "Text"
        Case 22
            DbTypeName = "Time"
        Case 23
            DbTypeName = "TimeStamp"
        Case 17
            DbTypeName = "VarBinary"
        Case Else
            DbTypeName = "Unknown"
    End Select
End Function

Private Sub cmdOpen_Click()
Dim db As DAO.Database
Dim table_def As TableDef
Dim table_node As Node
Dim field_node As Node
Dim index_node As Node
Dim field_obj As Field
Dim index_obj As Index
Dim txt As String

    ' Open the database.
    Set db = DAO.DBEngine(0).OpenDatabase(txtDatabaseName.Text)

    ' Clear the tree.
    If trvDatabase.Nodes.Count > 0 Then
        trvDatabase.Nodes(0).Expanded = False
        trvDatabase.Nodes.Clear
    End If

    ' Get Table information.
    For Each table_def In db.TableDefs
        ' Display the table's information.
        Set table_node = trvDatabase.Nodes.Add( _
            Text:=table_def.Name)

        ' Display field information.
        Set field_node = trvDatabase.Nodes.Add( _
            Relative:=table_node, _
            Relationship:=tvwChild, _
            Text:="Fields")
        For Each field_obj In table_def.Fields
            trvDatabase.Nodes.Add _
                Relative:=field_node, _
                Relationship:=tvwChild, _
                Text:=field_obj.Name & _
                    " (" & DbTypeName(field_obj.Type) & ")"
        Next field_obj

        ' Display index information.
        Set index_node = trvDatabase.Nodes.Add( _
            Relative:=table_node, _
            Relationship:=tvwChild, _
            Text:="Indexes")

        ' We will not have permission to read index
        ' information on the system tables.
        On Error Resume Next
        For Each index_obj In table_def.Indexes
            txt = ""
            For Each field_obj In index_obj.Fields
                txt = txt & ", " & field_obj.Name
            Next field_obj
            If Len(txt) > 0 Then txt = Mid$(txt, 3)
            trvDatabase.Nodes.Add _
                Relative:=index_node, _
                Relationship:=tvwChild, _
                Text:=index_obj.Name & _
                    " (" & txt & ")"
        Next index_obj
        On Error GoTo 0
    Next table_def

    db.Close
End Sub

Private Sub Form_Load()
Dim db_name As String

    ' Get the database name.
    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    db_name = db_name & "TestData.mdb"
    txtDatabaseName.Text = db_name
End Sub


Private Sub Form_Resize()
Const GAP As Single = 120
Dim hgt As Single
Dim wid As Single

    cmdOpen.Left = ScaleWidth - cmdOpen.Width - GAP

    wid = cmdOpen.Left - txtDatabaseName.Left - GAP
    If wid < GAP Then wid = GAP
    txtDatabaseName.Width = wid

    wid = ScaleWidth - 2 * GAP
    If wid < GAP Then wid = GAP
    hgt = ScaleHeight - trvDatabase.Top - GAP
    If hgt < GAP Then hgt = GAP
    trvDatabase.Width = wid
    trvDatabase.Height = hgt
End Sub
